package dk.netarkivet.harvester.webinterface;

import javax.servlet.jsp.JspWriter;
import java.io.File;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import dk.netarkivet.harvester.datamodel.IngestDomainList;

/**
 * This class manages a thead of ingesting domains.
 */

public class DomainIngester extends Thread {
    Log log = LogFactory.getLog(DomainIngester.class.getName());
    /** Whether the ingesting is done yet. */
    public boolean done = false;
    /** If an exception is thrown during ingest, it gets stored here. */
    public Exception e;
    private File ingestFile;
    private JspWriter out;

    /** Create a new ingester for a given session and outpout, reading
     * domains from a file.
     *
     * @param out The writer that goes into HTML output
     * @param ingestFile The file of domains to ingest.
     */
    public DomainIngester(JspWriter out, File ingestFile) {
        this.ingestFile = ingestFile;
        this.out = out;
    }

    /** Starts the ingesting thread.  When 'done' is set to true, the thread
     * is finished, and any exceptions are found in 'e'.
     */
    public void run() {
        try {
            new IngestDomainList().updateDomainInfo(ingestFile, out);
        } catch (Exception e) {
            this.e = e;
            log.warn("Update domains failed", e);
        } finally {
            done = true;
        }
    }
}
