/*$RCSfile: CrawlLogIndexCacheTester.java,v $
* $Revision: 1.7 $
* $Date: 2007/02/28 16:16:26 $
* $Author: kfc $
*
* The Netarchive Suite - Software to harvest and preserve websites
* Copyright 2004-2007 Det Kongelige Bibliotek and Statsbiblioteket, Denmark
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
package dk.netarkivet.archive.indexserver;
/**
 * lc forgot to comment this!
 */

import java.io.File;
import java.lang.reflect.Method;
import java.util.List;

import junit.framework.TestCase;

import dk.netarkivet.common.utils.FileUtils;
import dk.netarkivet.testutils.ReflectUtils;
import dk.netarkivet.testutils.TestFileUtils;


public class CrawlLogIndexCacheTester extends TestCase {
    public CrawlLogIndexCacheTester(String s) {
        super(s);
    }

    public void setUp() {
        TestFileUtils.copyDirectoryNonCVS(TestInfo.ORIGINALS_DIR,
                TestInfo.WORKING_DIR);
    }

    public void tearDown() {
        FileUtils.removeRecursively(TestInfo.WORKING_DIR);
    }

    public void testSortCrawlLog() throws Exception {
        Method sortCrawlLog
                = ReflectUtils.getPrivateMethod(CrawlLogIndexCache.class,
                "sortCrawlLog", File.class, File.class);
        File sortedFile = new File(TestInfo.CRAWL_LOG_1.getAbsolutePath() + ".sorted");
        sortCrawlLog.invoke(null, TestInfo.CRAWL_LOG_1, sortedFile);

        assertIsSortedCrawlLog("Should be sorted", sortedFile);
    }

    private void assertIsSortedCrawlLog(String msg, File f) {
        int urlField = 3;
        String prev = null;
        List<String> strings = FileUtils.readListFromFile(f);
        int i = 1;
        for (String s : strings) {
            String[] split = s.split("\\s+");
            String url = split[urlField];
            if (prev != null) {
                if (url.compareTo(prev) < 0) {
                    fail(msg + ": " + f + " unsorted at line " + i
                            + ":\n" + url + "\n" + prev);
                }
            }
            prev = url;
            i++;
        }
    }

}