/*$RCSfile: WebinterfaceTesterSuite.java,v $
* $Revision: 1.9 $
* $Date: 2007/04/30 12:06:04 $
* $Author: kfc $
*
* The Netarchive Suite - Software to harvest and preserve websites
* Copyright 2004-2007 Det Kongelige Bibliotek and Statsbiblioteket, Denmark
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
package dk.netarkivet.harvester.webinterface;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

import dk.netarkivet.archive.webinterface.BitpreserveFileStatusTester;
import dk.netarkivet.common.webinterface.HTMLUtilsTester;
import dk.netarkivet.common.webinterface.SiteSectionTester;

/**
 * A suite of webinterface tests.
 *
 */

public class WebinterfaceTesterSuite {
    public static Test suite() {
        TestSuite suite;
        suite = new TestSuite(WebinterfaceTesterSuite.class.getName());
        addToSuite(suite);
        return suite;
    }

    public static void addToSuite(TestSuite suite) {
        suite.addTestSuite(BitpreserveFileStatusTester.class);
        suite.addTestSuite(DomainDefinitionTester.class);
        suite.addTestSuite(EventHarvestTester.class);
        // Not quite working with JSP compilation yet
        //suite.addTestSuite(HarveststatusPerdomainTester.class);
        suite.addTestSuite(HistorySiteSectionTester.class);
        suite.addTestSuite(HTMLUtilsTester.class);
        suite.addTestSuite(ScheduleDefinitionTester.class);
        suite.addTestSuite(SelectiveHarvestTester.class);
        suite.addTestSuite(SiteSectionTester.class);
        suite.addTestSuite(SnapshotHarvestDefinitionTester.class);
        suite.addTestSuite(HarvestStatusTester.class);
    }

    public static void main(String args[]) {
        String args2[] = {"-noloading", WebinterfaceTesterSuite.class.getName()};

        TestRunner.main(args2);
    }
}
