<%--
File:       $RCSfile: Definitions-selective-harvests.jsp,v $
Revision:   $Revision: 1.3 $
Author:     $Author: lc $
Date:       $Date: 2007/05/22 14:09:00 $

The Netarchive Suite - Software to harvest and preserve websites
Copyright 2004-2007 Det Kongelige Bibliotek and Statsbiblioteket, Denmark

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

--%><%--
This page is a summary page displaying a list of all selective harvests known to
the system.
Parameters:
flipactive=<definitionName>
If set, the harvest-definition with the given name is changed from active to
inactive or vice-versa.
--%><%@ page import="dk.netarkivet.common.utils.I18n,
                 dk.netarkivet.common.webinterface.HTMLUtils,
                 dk.netarkivet.harvester.datamodel.HarvestDefinition,
                 dk.netarkivet.harvester.datamodel.HarvestDefinitionDAO,
                 dk.netarkivet.harvester.datamodel.SparsePartialHarvest,
                 dk.netarkivet.harvester.webinterface.Constants"
         pageEncoding="UTF-8"
%><%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"
%><fmt:setLocale value="<%=HTMLUtils.getLocale(request)%>" scope="page"
/><fmt:setBundle scope="page" basename="<%=dk.netarkivet.harvester.Constants.TRANSLATIONS_BUNDLE%>"/><%!
    private static final I18n I18N
            = new I18n(dk.netarkivet.harvester.Constants.TRANSLATIONS_BUNDLE);
%><%
    HTMLUtils.setUTF8(request);
    HarvestDefinitionDAO dao = HarvestDefinitionDAO.getInstance();
    String flipactive = request.getParameter("flipactive");
    // Change activation if requested
    if (flipactive != null) {
        HarvestDefinition hd = dao.getHarvestDefinition(flipactive);
        if (hd == null) {
            HTMLUtils.forwardWithErrorMessage(pageContext, I18N,
                    "errormsg;harvestdefinition.0.does.not.exist",
                    flipactive);
            return;
        } else {
            hd.setActive(!hd.getActive());
            HarvestDefinitionDAO.getInstance().update(hd);
            response.sendRedirect("Definitions-selective-harvests.jsp");
            return;
        }
    }
    HTMLUtils.generateHeader(pageContext);
%>

<h3 class="page_heading"><fmt:message key="pagetitle;selective.harvests"/></h3>

<table class="selection_table" cols="6">
    <tr>
        <th><fmt:message key="harvestdefinition.selective.header.harvestdefinition"/></th>
        <th><fmt:message key="harvestdefinition.selective.header.nextrun"/></th>
        <th colspan="4"></th>
    </tr>

    <%
        // Build the HTML page
        int rowCount = 0;

        for (SparsePartialHarvest sph
                : dao.getAllSparsePartialHarvestDefinitions()) {
            String name = sph.getName();
            String editLink = "Definitions-edit-selective-harvest.jsp?"
                    + Constants.HARVEST_PARAM + "="
                    + HTMLUtils.encode(name);
            String historicLink = "/History/Harveststatus-perhd.jsp?"
                    + Constants.HARVEST_PARAM + "="
                    + HTMLUtils.encode(name);

            String isActive;
            String flipActiveText;
            if (sph.isActive()) {
                isActive = I18N.getString(response.getLocale(),
                        "active");
                flipActiveText = I18N.getString(response.getLocale(),
                        "deactivate");
            } else {
                isActive = I18N.getString(response.getLocale(),
                        "inactive");
                flipActiveText = I18N.getString(response.getLocale(),
                        "activate");
            }
            String flipactiveLink
                    = "<a href=\"\" onclick=\"document.getElementById('flipActiveForm"
                    + sph.getOid() + "').submit(); return false;\">"
                    + HTMLUtils.escapeHtmlValues(flipActiveText)
                    + "</a>";
    %>
    <tr class="<%=HTMLUtils.getRowClass(rowCount++)%>">
        <td><%=HTMLUtils.escapeHtmlValues(name)%></td>
        <td>
        <% // Only output the date, if the HarvestDefinition is active
        if (sph.isActive()) { %>
           <fmt:formatDate type="both" value="<%=sph.getNextDate()%>"/>
        <% } else { out.print("-"); } %>
        </td>
        <td width="15%"><%=HTMLUtils.escapeHtmlValues(isActive)%></td>
        <td width="15%">
            <form id="flipActiveForm<%=sph.getOid()%>" action="Definitions-selective-harvests.jsp" method="post">
                <input type="hidden" name="<%=Constants.FLIPACTIVE_PARAM%>"
                       value="<%=HTMLUtils.escapeHtmlValues(sph.getName())%>"/>
                <%=flipactiveLink%>
            </form>
        </td>
        <td width="15%">
            <a href="<%=HTMLUtils.escapeHtmlValues(editLink)%>">
            	<fmt:message key="edit"/>
            </a>
        </td>
        <td width="15%">
            <a href="<%=HTMLUtils.escapeHtmlValues(historicLink)%>">
                <fmt:message key="harvestdefinition.linktext.historical"/>
                </a>
        </td>
    </tr>
    <%
        }
    %>
    <tr>
        <td colspan="6">
            <a href="Definitions-edit-selective-harvest.jsp?createnew=1">
                <fmt:message key="create.new.harvestdefinition"/></a>
        </td>
    </tr>
</table>
<%
    HTMLUtils.generateFooter(out);
%>